=== dependencies/mbedtls-2.24.0/programs/random/CMakeLists.txt ===
set(executables
    gen_entropy
    gen_random_ctr_drbg
    gen_random_havege
)

foreach(exe IN LISTS executables)
    add_executable(${exe} ${exe}.c $<TARGET_OBJECTS:mbedtls_test>)
    target_link_libraries(${exe} mbedcrypto)
endforeach()

install(TARGETS ${executables}
        DESTINATION "bin"
        PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
