=== debian/control ===
Source: openrgb
Maintainer: Adam Honse <calcprogrammer1@gmail.com>
Section: misc
Priority: optional
Standards-Version: 3.9.2
Build-Depends:
 debhelper (>= 9),
 pkg-config,
 qtbase5-dev,
 qtbase5-dev-tools,
 qttools5-dev-tools,
 qt5-qmake,
 libusb-1.0-0-dev,
 libhidapi-dev,
 libmbedtls-dev,
Homepage: https://gitlab.com/CalcProgrammer1/OpenRGB

Package: openrgb
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 udev,
Recommends:
 openrazer-driver-dkms,
 openrgb-dkms-drivers,
Conflicts:
 openrgb-udev,
Description: Open source RGB lighting control
 OpenRGB controls RGB lighting
